<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>Transaction.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper</a> &gt; <span class="el_source">Transaction.java</span></div><h1>Transaction.java</h1><pre class="source lang-java linenums">/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the &quot;License&quot;); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper;

import org.apache.zookeeper.AsyncCallback.MultiCallback;
import org.apache.zookeeper.data.ACL;
import java.util.ArrayList;
import java.util.List;

/**
 * Provides a builder style interface for doing multiple updates.  This is
 * really just a thin layer on top of Zookeeper.multi().
 *
 * @since 3.4.0
 *
 */
public class Transaction {
    private ZooKeeper zk;
<span class="fc" id="L34">    private List&lt;Op&gt; ops = new ArrayList&lt;Op&gt;();</span>

<span class="fc" id="L36">    protected Transaction(ZooKeeper zk) {</span>
<span class="fc" id="L37">        this.zk = zk;</span>
<span class="fc" id="L38">    }</span>

    public Transaction create(final String path, byte data[], List&lt;ACL&gt; acl,
                              CreateMode createMode) {
<span class="fc" id="L42">        ops.add(Op.create(path, data, acl, createMode.toFlag()));</span>
<span class="fc" id="L43">        return this;</span>
    }

    public Transaction delete(final String path, int version) {
<span class="fc" id="L47">        ops.add(Op.delete(path, version));</span>
<span class="fc" id="L48">        return this;</span>
    }

    public Transaction check(String path, int version) {
<span class="fc" id="L52">        ops.add(Op.check(path, version));</span>
<span class="fc" id="L53">        return this;</span>
    }

    public Transaction setData(final String path, byte data[], int version) {
<span class="fc" id="L57">        ops.add(Op.setData(path, data, version));</span>
<span class="fc" id="L58">        return this;</span>
    }

    public List&lt;OpResult&gt; commit() throws InterruptedException, KeeperException {
<span class="fc" id="L62">        return zk.multi(ops);</span>
    }

    public void commit(MultiCallback cb, Object ctx) {
<span class="fc" id="L66">        zk.multi(ops, cb, ctx);</span>
<span class="fc" id="L67">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>